? rnd2.diff
? arch/amd64/conf/NEWRND
? dev/.rndpseudo.c.swp
? dev/pci/.hifn7751.c.swp
? opencrypto/.cryptodev.c.swp
? opencrypto/.cryptodev.h.swp
Index: altq/altq_blue.c
===================================================================
RCS file: /cvsroot/src/sys/altq/altq_blue.c,v
retrieving revision 1.22
diff -u -b -r1.22 altq_blue.c
--- altq/altq_blue.c	4 Mar 2007 05:59:00 -0000	1.22
+++ altq/altq_blue.c	31 Oct 2011 04:29:06 -0000
@@ -80,6 +80,7 @@
 #include <sys/errno.h>
 #include <sys/kernel.h>
 #include <sys/kauth.h>
+#include <sys/cprng.h>
 
 #include <net/if.h>
 #include <net/if_types.h>
@@ -504,7 +505,7 @@
 static int
 drop_early(blue_t *rp)
 {
-	if ((arc4random() % rp->blue_max_pmark) < rp->blue_pmark) {
+	if ((cprng_fast32() % rp->blue_max_pmark) < rp->blue_pmark) {
 		/* drop or mark */
 		return (1);
 	}
Index: altq/altq_cdnr.c
===================================================================
RCS file: /cvsroot/src/sys/altq/altq_cdnr.c,v
retrieving revision 1.19
diff -u -b -r1.19 altq_cdnr.c
--- altq/altq_cdnr.c	4 Mar 2007 05:59:01 -0000	1.19
+++ altq/altq_cdnr.c	31 Oct 2011 04:29:06 -0000
@@ -46,6 +46,7 @@
 #include <sys/kernel.h>
 #include <sys/queue.h>
 #include <sys/kauth.h>
+#include <sys/cprng.h>
 
 #include <net/if.h>
 #include <net/if_types.h>
@@ -801,7 +802,7 @@
 	 * marker
 	 */
 	if (avg_rate > tsw->cmtd_rate) {
-		u_int32_t randval = arc4random() % avg_rate;
+		u_int32_t randval = cprng_fast32() % avg_rate;
 
 		if (avg_rate > tsw->peak_rate) {
 			if (randval < avg_rate - tsw->peak_rate) {
Index: altq/altq_red.c
===================================================================
RCS file: /cvsroot/src/sys/altq/altq_red.c,v
retrieving revision 1.28
diff -u -b -r1.28 altq_red.c
--- altq/altq_red.c	18 Jun 2008 09:06:27 -0000	1.28
+++ altq/altq_red.c	31 Oct 2011 04:29:06 -0000
@@ -87,6 +87,7 @@
 #include <sys/time.h>
 #endif
 #endif /* ALTQ3_COMPAT */
+#include <sys/cprng.h>
 
 #include <net/if.h>
 
@@ -505,7 +506,7 @@
 	 * drop probability = (avg - TH_MIN) / d
 	 */
 
-	if ((arc4random() % d) < fp_len) {
+	if ((cprng_fast32() % d) < fp_len) {
 		/* drop or mark */
 		return (1);
 	}
Index: altq/altq_rmclass.c
===================================================================
RCS file: /cvsroot/src/sys/altq/altq_rmclass.c,v
retrieving revision 1.21
diff -u -b -r1.21 altq_rmclass.c
--- altq/altq_rmclass.c	15 Jul 2008 16:18:08 -0000	1.21
+++ altq/altq_rmclass.c	31 Oct 2011 04:29:07 -0000
@@ -59,6 +59,7 @@
 #ifdef ALTQ3_COMPAT
 #include <sys/kernel.h>
 #endif
+#include <sys/cprng.h>
 
 #include <net/if.h>
 #ifdef ALTQ3_COMPAT
@@ -1777,7 +1778,7 @@
 	} else {
 		struct mbuf *prev = NULL;
 
-		n = arc4random() % qlen(q) + 1;
+		n = cprng_fast32() % qlen(q) + 1;
 		for (i = 0; i < n; i++) {
 			prev = m;
 			m = m->m_nextpkt;
Index: arch/acorn26/ioc/arckbd.c
===================================================================
RCS file: /cvsroot/src/sys/arch/acorn26/ioc/arckbd.c,v
retrieving revision 1.20
diff -u -b -r1.20 arckbd.c
--- arch/acorn26/ioc/arckbd.c	19 Jul 2011 16:05:10 -0000	1.20
+++ arch/acorn26/ioc/arckbd.c	31 Oct 2011 04:29:07 -0000
@@ -139,7 +139,7 @@
 	struct irq_handler	*sc_rirq;
 	struct evcnt		sc_rev;
 #if NRND > 0
-	rndsource_element_t	sc_rnd_source;
+	krndsource_t	sc_rnd_source;
 #endif
 };
 
Index: arch/arm/at91/at91dbguvar.h
===================================================================
RCS file: /cvsroot/src/sys/arch/arm/at91/at91dbguvar.h,v
retrieving revision 1.3
diff -u -b -r1.3 at91dbguvar.h
--- arch/arm/at91/at91dbguvar.h	23 Oct 2009 06:53:13 -0000	1.3
+++ arch/arm/at91/at91dbguvar.h	31 Oct 2011 04:29:07 -0000
@@ -82,7 +82,7 @@
 
 	int			enabled;
 #if NRND > 0 && defined(RND_COM)
-	rndsource_element_t  rnd_source;
+	krndsource_t  rnd_source;
 #endif
 };
 
Index: arch/arm/at91/at91usartvar.h
===================================================================
RCS file: /cvsroot/src/sys/arch/arm/at91/at91usartvar.h,v
retrieving revision 1.3
diff -u -b -r1.3 at91usartvar.h
--- arch/arm/at91/at91usartvar.h	23 Oct 2009 06:53:13 -0000	1.3
+++ arch/arm/at91/at91usartvar.h	31 Oct 2011 04:29:07 -0000
@@ -86,7 +86,7 @@
 
 	int			enabled;
 #if NRND > 0 && defined(RND_COM)
-	rndsource_element_t  rnd_source;
+	krndsource_t  rnd_source;
 #endif
 };
 
Index: arch/arm/ep93xx/epcomvar.h
===================================================================
RCS file: /cvsroot/src/sys/arch/arm/ep93xx/epcomvar.h,v
retrieving revision 1.4
diff -u -b -r1.4 epcomvar.h
--- arch/arm/ep93xx/epcomvar.h	23 Oct 2009 00:39:30 -0000	1.4
+++ arch/arm/ep93xx/epcomvar.h	31 Oct 2011 04:29:07 -0000
@@ -83,7 +83,7 @@
 
 	int			enabled;
 #if NRND > 0 && defined(RND_COM)
-	rndsource_element_t  rnd_source;
+	krndsource_t  rnd_source;
 #endif
 };
 
Index: arch/arm/s3c2xx0/sscom_var.h
===================================================================
RCS file: /cvsroot/src/sys/arch/arm/s3c2xx0/sscom_var.h,v
retrieving revision 1.8
diff -u -b -r1.8 sscom_var.h
--- arch/arm/s3c2xx0/sscom_var.h	1 Jul 2011 20:31:39 -0000	1.8
+++ arch/arm/s3c2xx0/sscom_var.h	31 Oct 2011 04:29:07 -0000
@@ -172,7 +172,7 @@
 #endif
 
 #if NRND > 0 && defined(RND_COM)
-	rndsource_element_t  rnd_source;
+	krndsource_t  rnd_source;
 #endif
 #if (defined(MULTIPROCESSOR) || defined(LOCKDEBUG)) && defined(SSCOM_MPLOCK)
 	struct simplelock	sc_lock;
Index: arch/arm/sa11x0/sa1111_kbc.c
===================================================================
RCS file: /cvsroot/src/sys/arch/arm/sa11x0/sa1111_kbc.c,v
retrieving revision 1.12
diff -u -b -r1.12 sa1111_kbc.c
--- arch/arm/sa11x0/sa1111_kbc.c	13 Mar 2010 11:13:31 -0000	1.12
+++ arch/arm/sa11x0/sa1111_kbc.c	31 Oct 2011 04:29:07 -0000
@@ -96,7 +96,7 @@
 	int	poll_data;	/* status read from intr handler if polling */
 
 #if NRND > 0
-	rndsource_element_t	rnd_source;
+	krndsource_t	rnd_source;
 #endif
 	pckbport_tag_t pt;
 };
Index: arch/arm/xscale/ixp425_if_npe.c
===================================================================
RCS file: /cvsroot/src/sys/arch/arm/xscale/ixp425_if_npe.c,v
retrieving revision 1.20
diff -u -b -r1.20 ixp425_if_npe.c
--- arch/arm/xscale/ixp425_if_npe.c	1 Jul 2011 20:32:51 -0000	1.20
+++ arch/arm/xscale/ixp425_if_npe.c	31 Oct 2011 04:29:08 -0000
@@ -127,7 +127,7 @@
 	bus_addr_t	sc_stats_phys;	/* phys addr of sc_stats */
 	int		sc_if_flags;	/* keep last if_flags */
 #if NRND > 0
-	rndsource_element_t rnd_source; /* random source */
+	krndsource_t rnd_source; /* random source */
 #endif
 };
 
Index: arch/emips/ebus/ace_ebus.c
===================================================================
RCS file: /cvsroot/src/sys/arch/emips/ebus/ace_ebus.c,v
retrieving revision 1.2
diff -u -b -r1.2 ace_ebus.c
--- arch/emips/ebus/ace_ebus.c	18 Jun 2011 17:47:20 -0000	1.2
+++ arch/emips/ebus/ace_ebus.c	31 Oct 2011 04:29:09 -0000
@@ -193,7 +193,7 @@
 	int retries; /* number of xfer retry */
 
 #if NRND > 0
-	rndsource_element_t	rnd_source;
+	krndsource_t	rnd_source;
 #endif
 };
 
Index: arch/emips/ebus/flash_ebus.c
===================================================================
RCS file: /cvsroot/src/sys/arch/emips/ebus/flash_ebus.c,v
retrieving revision 1.2
diff -u -b -r1.2 flash_ebus.c
--- arch/emips/ebus/flash_ebus.c	12 Jun 2011 03:29:33 -0000	1.2
+++ arch/emips/ebus/flash_ebus.c	31 Oct 2011 04:29:09 -0000
@@ -202,7 +202,7 @@
 	int retries; /* number of xfer retry */
 
 #if NRND > 0
-	rndsource_element_t	rnd_source;
+	krndsource_t	rnd_source;
 #endif
 
     /* flash-specific state */
Index: arch/emips/ebus/if_le_ebus.c
===================================================================
RCS file: /cvsroot/src/sys/arch/emips/ebus/if_le_ebus.c,v
retrieving revision 1.2
diff -u -b -r1.2 if_le_ebus.c
--- arch/emips/ebus/if_le_ebus.c	12 Jun 2011 14:31:31 -0000	1.2
+++ arch/emips/ebus/if_le_ebus.c	31 Oct 2011 04:29:09 -0000
@@ -115,7 +115,7 @@
 	uint8_t sc_enaddr[ETHER_ADDR_LEN];
 	uint8_t sc_pad[2];
 #if NRND > 0
-	rndsource_element_t	rnd_source;
+	krndsource_t	rnd_source;
 #endif
 };
 
Index: arch/evbarm/dev/plcomvar.h
===================================================================
RCS file: /cvsroot/src/sys/arch/evbarm/dev/plcomvar.h,v
retrieving revision 1.6
diff -u -b -r1.6 plcomvar.h
--- arch/evbarm/dev/plcomvar.h	5 Jan 2008 12:40:34 -0000	1.6
+++ arch/evbarm/dev/plcomvar.h	31 Oct 2011 04:29:10 -0000
@@ -134,7 +134,7 @@
 	pps_params_t ppsparam;
 
 #if NRND > 0 && defined(RND_COM)
-	rndsource_element_t  rnd_source;
+	krndsource_t  rnd_source;
 #endif
 	struct simplelock	sc_lock;
 };
Index: arch/hp300/dev/rdvar.h
===================================================================
RCS file: /cvsroot/src/sys/arch/hp300/dev/rdvar.h,v
retrieving revision 1.20
diff -u -b -r1.20 rdvar.h
--- arch/hp300/dev/rdvar.h	8 Feb 2011 20:20:13 -0000	1.20
+++ arch/hp300/dev/rdvar.h	31 Oct 2011 04:29:10 -0000
@@ -81,7 +81,7 @@
 	int	sc_errcnt;
 	struct	rdstats sc_stats;
 #if NRND > 0
-	rndsource_element_t rnd_source;
+	krndsource_t rnd_source;
 #endif
 };
 
Index: arch/hp700/gsc/harmonyvar.h
===================================================================
RCS file: /cvsroot/src/sys/arch/hp700/gsc/harmonyvar.h,v
retrieving revision 1.4
diff -u -b -r1.4 harmonyvar.h
--- arch/hp700/gsc/harmonyvar.h	25 Apr 2008 08:17:52 -0000	1.4
+++ arch/hp700/gsc/harmonyvar.h	31 Oct 2011 04:29:10 -0000
@@ -105,7 +105,7 @@
 	int sc_teleshare;
 
 #if NRND > 0
-	rndsource_element_t sc_rnd_source;
+	krndsource_t sc_rnd_source;
 	struct callout sc_acc_tmo;
 	uint32_t sc_acc, sc_acc_num, sc_acc_cnt;
 #endif
Index: arch/i386/pci/glxsb.c
===================================================================
RCS file: /cvsroot/src/sys/arch/i386/pci/glxsb.c,v
retrieving revision 1.9
diff -u -b -r1.9 glxsb.c
--- arch/i386/pci/glxsb.c	16 May 2009 16:52:03 -0000	1.9
+++ arch/i386/pci/glxsb.c	31 Oct 2011 04:29:10 -0000
@@ -34,8 +34,8 @@
 #include <sys/mbuf.h>
 #include <sys/types.h>
 #include <sys/callout.h>
-#include <sys/rnd.h>
 #include <sys/bus.h>
+#include <sys/cprng.h>
 
 #include <machine/cpufunc.h>
 
@@ -165,7 +165,7 @@
 	int			sc_nsessions;
 	struct glxsb_session	*sc_sessions;
 
-	rndsource_element_t	sc_rnd_source;
+	krndsource_t	sc_rnd_source;
 };
 
 int	glxsb_match(device_t, cfdata_t, void *);
@@ -343,7 +343,7 @@
 	memset(ses, 0, sizeof(*ses));
 	ses->ses_used = 1;
 
-	arc4randbytes(ses->ses_iv, sizeof(ses->ses_iv));
+	cprng_fast(ses->ses_iv, sizeof(ses->ses_iv));
 	ses->ses_klen = cri->cri_klen;
 
 	/* Copy the key (Geode LX wants the primary key only) */
Index: arch/macppc/dev/if_gm.c
===================================================================
RCS file: /cvsroot/src/sys/arch/macppc/dev/if_gm.c,v
retrieving revision 1.39
diff -u -b -r1.39 if_gm.c
--- arch/macppc/dev/if_gm.c	18 Jun 2011 08:08:28 -0000	1.39
+++ arch/macppc/dev/if_gm.c	31 Oct 2011 04:29:11 -0000
@@ -87,7 +87,7 @@
 	char sc_laddr[6];
 
 #if NRND > 0
-	rndsource_element_t sc_rnd_source; /* random source */
+	krndsource_t sc_rnd_source; /* random source */
 #endif
 };
 
Index: arch/mips/alchemy/dev/if_aumac.c
===================================================================
RCS file: /cvsroot/src/sys/arch/mips/alchemy/dev/if_aumac.c,v
retrieving revision 1.31
diff -u -b -r1.31 if_aumac.c
--- arch/mips/alchemy/dev/if_aumac.c	10 Jul 2011 23:13:23 -0000	1.31
+++ arch/mips/alchemy/dev/if_aumac.c	31 Oct 2011 04:29:11 -0000
@@ -143,7 +143,7 @@
 	int sc_rxptr;			/* next ready Rx descriptor */
 
 #if NRND > 0
-	rndsource_element_t rnd_source;
+	krndsource_t rnd_source;
 #endif
 
 #ifdef AUMAC_EVENT_COUNTERS
Index: arch/mips/atheros/dev/aevar.h
===================================================================
RCS file: /cvsroot/src/sys/arch/mips/atheros/dev/aevar.h,v
retrieving revision 1.3
diff -u -b -r1.3 aevar.h
--- arch/mips/atheros/dev/aevar.h	28 Apr 2008 20:23:28 -0000	1.3
+++ arch/mips/atheros/dev/aevar.h	31 Oct 2011 04:29:11 -0000
@@ -187,7 +187,7 @@
 	int	sc_rxptr;		/* next ready RX descriptor/descsoft */
 
 #if NRND > 0
-	rndsource_element_t sc_rnd_source; /* random source */
+	krndsource_t sc_rnd_source; /* random source */
 #endif
 };
 #endif
Index: arch/mips/sibyte/dev/sbscnvar.h
===================================================================
RCS file: /cvsroot/src/sys/arch/mips/sibyte/dev/sbscnvar.h,v
retrieving revision 1.4
diff -u -b -r1.4 sbscnvar.h
--- arch/mips/sibyte/dev/sbscnvar.h	1 Feb 2011 03:16:54 -0000	1.4
+++ arch/mips/sibyte/dev/sbscnvar.h	31 Oct 2011 04:29:11 -0000
@@ -157,7 +157,7 @@
 	u_char		ch_o_dtr_pin, ch_o_rts_pin;
 
 #if NRND > 0 && defined(RND_SBSCN)
-	rndsource_element_t  ch_rnd_source;
+	krndsource_t  ch_rnd_source;
 #endif
 };
 
Index: arch/next68k/dev/mb8795var.h
===================================================================
RCS file: /cvsroot/src/sys/arch/next68k/dev/mb8795var.h,v
retrieving revision 1.11
diff -u -b -r1.11 mb8795var.h
--- arch/next68k/dev/mb8795var.h	24 Apr 2010 19:58:13 -0000	1.11
+++ arch/next68k/dev/mb8795var.h	31 Oct 2011 04:29:11 -0000
@@ -72,7 +72,7 @@
 	struct ifmedia sc_media;
 
 #if NRND > 0
-	rndsource_element_t     rnd_source;
+	krndsource_t     rnd_source;
 #endif /* NRND */
 
 };
Index: arch/sgimips/hpc/sqvar.h
===================================================================
RCS file: /cvsroot/src/sys/arch/sgimips/hpc/sqvar.h,v
retrieving revision 1.12
diff -u -b -r1.12 sqvar.h
--- arch/sgimips/hpc/sqvar.h	25 Jan 2011 13:12:39 -0000	1.12
+++ arch/sgimips/hpc/sqvar.h	31 Oct 2011 04:29:12 -0000
@@ -157,7 +157,7 @@
 	struct evcnt		sq_intrcnt;	/* count interrupts */
 
 #if NRND > 0
-	rndsource_element_t	rnd_source;	/* random source */
+	krndsource_t	rnd_source;	/* random source */
 #endif
 	struct hpc_values       *hpc_regs;      /* HPC register definitions */
 
Index: arch/sgimips/mace/if_mec.c
===================================================================
RCS file: /cvsroot/src/sys/arch/sgimips/mace/if_mec.c,v
retrieving revision 1.46
diff -u -b -r1.46 if_mec.c
--- arch/sgimips/mace/if_mec.c	1 Jul 2011 18:53:47 -0000	1.46
+++ arch/sgimips/mace/if_mec.c	31 Oct 2011 04:29:12 -0000
@@ -317,7 +317,7 @@
 	int sc_rxptr;			/* next ready RX buffer */
 
 #if NRND > 0
-	rndsource_element_t sc_rnd_source; /* random source */
+	krndsource_t sc_rnd_source; /* random source */
 #endif
 #ifdef MEC_EVENT_COUNTERS
 	struct evcnt sc_ev_txpkts;	/* TX packets queued total */
Index: arch/sun2/dev/if_ec.c
===================================================================
RCS file: /cvsroot/src/sys/arch/sun2/dev/if_ec.c,v
retrieving revision 1.18
diff -u -b -r1.18 if_ec.c
--- arch/sun2/dev/if_ec.c	5 Apr 2010 07:19:32 -0000	1.18
+++ arch/sun2/dev/if_ec.c	31 Oct 2011 04:29:12 -0000
@@ -102,7 +102,7 @@
 	uint32_t sc_backoff_seed;	/* seed for the backoff PRNG */
 
 #if NRND > 0
-	rndsource_element_t rnd_source;
+	krndsource_t rnd_source;
 #endif
 };
 
Index: arch/x68k/dev/fd.c
===================================================================
RCS file: /cvsroot/src/sys/arch/x68k/dev/fd.c,v
retrieving revision 1.94
diff -u -b -r1.94 fd.c
--- arch/x68k/dev/fd.c	10 Apr 2011 15:23:06 -0000	1.94
+++ arch/x68k/dev/fd.c	31 Oct 2011 04:29:12 -0000
@@ -245,7 +245,7 @@
 #define	SEC_P11	0x03		/* both part */
 
 #if NRND > 0
-	rndsource_element_t	rnd_source;
+	krndsource_t	rnd_source;
 #endif
 };
 
Index: arch/x86/include/via_padlock.h
===================================================================
RCS file: /cvsroot/src/sys/arch/x86/include/via_padlock.h,v
retrieving revision 1.6
diff -u -b -r1.6 via_padlock.h
--- arch/x86/include/via_padlock.h	19 Feb 2011 13:52:28 -0000	1.6
+++ arch/x86/include/via_padlock.h	31 Oct 2011 04:29:12 -0000
@@ -61,7 +61,7 @@
 
 	int			sc_rnd_hz;
 	struct callout		sc_rnd_co;
-	rndsource_element_t	sc_rnd_source;
+	krndsource_t	sc_rnd_source;
 	bool			sc_rnd_attached;
 
 	/* normal softc stuff */
Index: arch/x86/pci/fwhrng.c
===================================================================
RCS file: /cvsroot/src/sys/arch/x86/pci/fwhrng.c,v
retrieving revision 1.3
diff -u -b -r1.3 fwhrng.c
--- arch/x86/pci/fwhrng.c	1 Jul 2011 18:22:08 -0000	1.3
+++ arch/x86/pci/fwhrng.c	31 Oct 2011 04:29:12 -0000
@@ -54,7 +54,7 @@
 	bus_space_handle_t sc_sh;
 
 	struct callout sc_rnd_ch;
-	rndsource_element_t sc_rnd_source;
+	krndsource_t sc_rnd_source;
 
 	int sc_rnd_i;
 	uint32_t sc_rnd_ax;
Index: arch/x86/x86/via_padlock.c
===================================================================
RCS file: /cvsroot/src/sys/arch/x86/x86/via_padlock.c,v
retrieving revision 1.15
diff -u -b -r1.15 via_padlock.c
--- arch/x86/x86/via_padlock.c	24 May 2011 18:59:21 -0000	1.15
+++ arch/x86/x86/via_padlock.c	31 Oct 2011 04:29:12 -0000
@@ -258,8 +258,7 @@
 				C3_CRYPT_CWLO_KEYGEN_SW |
 				C3_CRYPT_CWLO_NORMAL;
 
-			rnd_extract_data(ses->ses_iv, sizeof(ses->ses_iv),
-			    RND_EXTRACT_ANY);
+			arc4randbytes(ses->ses_iv, sizeof(ses->ses_iv));
 			ses->ses_klen = c->cri_klen;
 			ses->ses_cw0 = cw0;
 
Index: arch/xen/include/xbdvar.h
===================================================================
RCS file: /cvsroot/src/sys/arch/xen/include/xbdvar.h,v
retrieving revision 1.12
diff -u -b -r1.12 xbdvar.h
--- arch/xen/include/xbdvar.h	23 Oct 2009 02:32:33 -0000	1.12
+++ arch/xen/include/xbdvar.h	31 Oct 2011 04:29:12 -0000
@@ -40,7 +40,7 @@
 	struct simplelock	sc_slock;	/* our lock */
 	int			sc_shutdown;	/* about to be removed */
 #if NRND > 0
-	rndsource_element_t	sc_rnd_source;
+	krndsource_t	sc_rnd_source;
 #endif
 };
 
Index: arch/xen/xen/if_xennet_xenbus.c
===================================================================
RCS file: /cvsroot/src/sys/arch/xen/xen/if_xennet_xenbus.c,v
retrieving revision 1.53
diff -u -b -r1.53 if_xennet_xenbus.c
--- arch/xen/xen/if_xennet_xenbus.c	26 Sep 2011 21:44:09 -0000	1.53
+++ arch/xen/xen/if_xennet_xenbus.c	31 Oct 2011 04:29:13 -0000
@@ -203,7 +203,7 @@
 #define FEATURE_RX_FLIP		0
 #define FEATURE_RX_COPY		1
 #if NRND > 0
-	rndsource_element_t     sc_rnd_source;
+	krndsource_t     sc_rnd_source;
 #endif
 };
 #define SC_NLIVEREQ(sc) ((sc)->sc_rx_ring.req_prod_pvt - \
Index: arch/xen/xen/xbd_xenbus.c
===================================================================
RCS file: /cvsroot/src/sys/arch/xen/xen/xbd_xenbus.c,v
retrieving revision 1.48
diff -u -b -r1.48 xbd_xenbus.c
--- arch/xen/xen/xbd_xenbus.c	20 Sep 2011 00:12:24 -0000	1.48
+++ arch/xen/xen/xbd_xenbus.c	31 Oct 2011 04:29:13 -0000
@@ -155,7 +155,7 @@
 	u_long sc_handle; /* from backend */
 	int sc_cache_flush; /* backend supports BLKIF_OP_FLUSH_DISKCACHE */
 #if NRND > 0
-	rndsource_element_t     sc_rnd_source;
+	krndsource_t     sc_rnd_source;
 #endif
 };
 
Index: conf/files
===================================================================
RCS file: /cvsroot/src/sys/conf/files,v
retrieving revision 1.1029
diff -u -b -r1.1029 files
--- conf/files	15 Oct 2011 00:23:08 -0000	1.1029
+++ conf/files	31 Oct 2011 04:29:13 -0000
@@ -165,10 +165,12 @@
 include "crypto/rijndael/files.rijndael"
 include "crypto/skipjack/files.skipjack"
 include "crypto/camellia/files.camellia"
-
 # General-purpose crypto processing framework.
 include "opencrypto/files.opencrypto"
 
+# NIST SP800.90 CTR DRBG
+include "crypto/nist_ctr_drbg/files.nist_ctr_drbg"
+
 #
 # Kernel history/tracing. Old UVMHIST depends upon this.
 #
@@ -392,7 +394,7 @@
 define	ieee1394
 define	token
 define	sppp
-define	wlan: rijndael
+define	wlan
 define	crypto
 
 # devices ARPing IPv4 pull this in:
@@ -1280,7 +1282,7 @@
 defpseudodev vnd:	disk
 defflag opt_vnd.h	VND_COMPRESSION
 defpseudo ccd:		disk
-defpseudodev cgd:	disk, des, blowfish, cast128, rijndael
+defpseudodev cgd:	disk, des, blowfish, cast128
 defpseudodev md:	disk
 defpseudodev fss:	disk
 
@@ -1521,10 +1523,12 @@
 file	kern/kgdb_stub.c		kgdb
 file	kern/sched_4bsd.c		sched_4bsd
 file	kern/sched_m2.c			sched_m2
+file	kern/subr_rngtest.c
 file	kern/subr_autoconf.c
 file	kern/subr_blist.c		vmswap
 file	kern/subr_bufq.c
 file	kern/subr_callback.c
+file	kern/subr_cprng.c
 file	kern/subr_cpufreq.c
 file	kern/subr_copy.c
 file	kern/subr_debug.c		debug
Index: crypto/nist_ctr_drbg/files.nist_ctr_drbg
===================================================================
RCS file: crypto/nist_ctr_drbg/files.nist_ctr_drbg
diff -N crypto/nist_ctr_drbg/files.nist_ctr_drbg
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ crypto/nist_ctr_drbg/files.nist_ctr_drbg	31 Oct 2011 04:29:13 -0000
@@ -0,0 +1,3 @@
+#	$NetBSD: files.rijndael,v 1.5 2005/12/11 12:20:52 christos Exp $
+
+file	crypto/nist_ctr_drbg/nist_ctr_drbg.c
Index: crypto/nist_ctr_drbg/nist_ctr_aes_rijndael.h
===================================================================
RCS file: crypto/nist_ctr_drbg/nist_ctr_aes_rijndael.h
diff -N crypto/nist_ctr_drbg/nist_ctr_aes_rijndael.h
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ crypto/nist_ctr_drbg/nist_ctr_aes_rijndael.h	31 Oct 2011 04:29:13 -0000
@@ -0,0 +1,49 @@
+/*
+ * Copyright (c) 2007 Henric Jungheim <software@henric.info>
+ *
+ * Permission to use, copy, modify, and distribute this software for any
+ * purpose with or without fee is hereby granted, provided that the above
+ * copyright notice and this permission notice appear in all copies.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
+ * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
+ * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
+ * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
+ * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
+ * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
+ * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
+ */
+
+/*
+ * Interface adapter for Rijndael implmentation (for use by NIST SP 800-90 CTR_DRBG)
+ */
+
+#ifndef NIST_AES_RIJNDAEL_H
+#define NIST_AES_RIJNDAEL_H
+
+#include <crypto/rijndael/rijndael.h>
+
+#define NIST_AES_MAXKEYBITS		256
+#define NIST_AES_MAXKEYBYTES	(NIST_AES_MAXKEYBITS / 8)
+#define NIST_AES_MAXKEYINTS	(NIST_AES_MAXKEYBYTES / sizeof(int))
+
+#define NIST_AES_BLOCKSIZEBITS	128
+#define NIST_AES_BLOCKSIZEBYTES	(NIST_AES_BLOCKSIZEBITS / 8)
+#define NIST_AES_BLOCKSIZEINTS	(NIST_AES_BLOCKSIZEBYTES / sizeof(int))
+
+typedef rijndael_ctx NIST_AES_ENCRYPT_CTX;
+
+static __inline void
+NIST_AES_ECB_Encrypt(const NIST_AES_ENCRYPT_CTX* ctx, const void* src, void* dst)
+{
+	rijndael_encrypt(ctx, src, dst);
+}
+
+static __inline int
+NIST_AES_Schedule_Encryption(NIST_AES_ENCRYPT_CTX* ctx, const void* key, int bits)
+{
+	rijndael_set_key(ctx, key, bits);
+	return 0;
+}
+
+#endif /* NIST_AES_RIJNDAEL_H */
